<template>
  <div class="container-main" ref="main">
    <div class="search-hearder" ref="topSearch">
      <el-form
        :model="queryParams"
        ref="queryForm"
        :inline="true"
        v-show="showSearch"
      >
        <el-form-item label="名称" prop="name">
          <el-input
            v-model="queryParams.name"
            placeholder="请输入名称"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索</el-button
          >
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
            >重置</el-button
          >
        </el-form-item>
      </el-form>
    </div>
    <div class="layui-table-tool" ref="tableTool">
      <el-button
        type="primary"
        size="mini"
        @click="handleAdd()"
        v-hasPermi="['tcZz/netManage:ytlc:add']"
        >新增</el-button
      >
      <el-button
        type="success"
        size="mini"
        :disabled="single"
        @click="handleUpdate"
        v-hasPermi="['tcZz/netManage:ytlc:edit']"
        >修改</el-button
      >
      <el-button
        type="danger"
        size="mini"
        :disabled="multiple"
        @click="handleDelete"
        v-hasPermi="['tcZz/netManage:ytlc:remove']"
        >删除</el-button
      >
      <el-button type="primary" size="mini" @click="exportFile">导入</el-button>

      <el-button
        type="warning"
        size="mini"
        :loading="exportLoading"
        @click="handleExport"
        v-hasPermi="['tcZz/netManage:ytlc:export']"
        >导出</el-button
      >
    </div>
    <el-table
      v-loading="loading"
      :data="ytlcList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="序号" align="center" prop="id" /> -->
      <el-table-column label="名称" align="center" prop="name" />
      <el-table-column label="文件名称" align="center" prop="fileName" />
      <!-- <el-table-column label="文件路径(完整路径)" align="center" prop="fileUrl" />
              <el-table-column label="备注" align="center" prop="remark" /> -->
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        width="200"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            @click="handleInfo(scope.row)"
            v-hasPermi="['tcZz/netManage:ytlc:list']"
          >
            查看
          </el-button>
          <el-button
            type="success"
            size="mini"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['tcZz/netManage:ytlc:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="danger"
            @click="handleDelete(scope.row)"
            v-hasPermi="['tcZz/netManage:ytlc:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改约谈流程对话框 -->
    <el-dialog
      :visible.sync="open"
      width="600px"
      append-to-body
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ title }}</div>
      <el-form
        ref="form"
        :model="form"
        :rules="rules"
        label-width="auto"
        class="dialog-from"
      >
        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="上传文件">
          <!-- <el-button @click="addDomain" type="primary">添加文件</el-button> -->
          <!-- <el-form-item label="文件路径(完整路径)"> -->
          <fileUpload v-model="fileNameS" :limit="1" />
          <!-- </el-form-item> -->
        </el-form-item>
        <!-- <div v-for="(domain, index) in form.domains" :key="index" class="file-item">
          <el-form-item
            label="文件名称"
            :prop="'domains.' + index + '.fileName'"
            :rules="{
              required: true, message: '文件名称不能为空', trigger: 'blur'
            }"
          >
            <el-input v-model="domain.fileName" placeholder="请输入文件名称"></el-input>
          </el-form-item>
          <el-form-item
            label="文件路径"
            :prop="'domains.' + index + '.fileUrl'"
            :rules="{
              required: true, message: '文件路径不能为空', trigger: 'blur'
            }"
          >
            <el-input v-model="domain.fileUrl" placeholder="请输入文件路径"></el-input>
          </el-form-item>
          <el-button @click.prevent="removeDomain(domain)" type="danger" size="mini">删除</el-button>
        </div> -->
        <el-form-item label="备注" prop="remark">
          <!-- <el-input v-model="form.remark" placeholder="请输入备注" /> -->
          <el-input
            v-model="form.remark"
            resize="none"
            :rows="5"
            type="textarea"
            placeholder="请输入备注"
          />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--查看约谈流程详情页-->
    <el-dialog
      :visible.sync="infoOpen"
      width="90%"
      append-to-body
      :close-on-click-modal="false"
      :destroy-on-close="true"
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ infoTitle }}</div>

      <el-descriptions
        title="约谈流程"
        :column="2"
        border
        labelClassName="desLable"
      >
        <el-descriptions-item label="名称">{{
          form.name
        }}</el-descriptions-item>

        <!-- <el-descriptions-item label="文件名称">{{ form.fileName }}</el-descriptions-item> -->

        <el-descriptions-item label="文件"
          ><a
            v-for="(item, index) in files"
            :key="index"
            :href="item.url"
            target="blank"
            >{{ item.name }}</a
          ></el-descriptions-item
        >

        <!-- <el-descriptions-item label="文件路径(完整路径)">{{ form.fileUrl }}</el-descriptions-item> -->

        <el-descriptions-item label="备注">{{
          form.remark
        }}</el-descriptions-item>
      </el-descriptions>
    </el-dialog>
    <import-dialog
      ref="importdialog"
      propsUrl="/tcZz/netManage/ytlc/common/importExcel"
      importUrl="/tcZz/netManage/ytlc/importTemplate"
      importName="约谈流程"
      :getList="getList"
    ></import-dialog>
  </div>
</template>

<script>
import {
  listYtlc,
  getYtlc,
  delYtlc,
  addYtlc,
  updateYtlc,
  exportYtlc,
} from "@/api/tcZz/netManage/ytlc";
import importDialog from "@/views/components/importDialog/index.vue"

export default {
  name: "Ytlc",
  components: { importDialog },
  //注释字典
  data() {
    return {
      tableHeigth: 0,
      //查看详情
      infoOpen: false,
      //详情标题
      infoTitle: "",
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 约谈流程表格数据
      ytlcList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 备注时间范围
      daterangeCreateTime: [],
      // 备注时间范围
      daterangeUpdateTime: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        id: null,

        name: null,

        fileName: null,

        fileUrl: null,

        createBy: null,

        createTime: null,

        updateBy: null,

        updateTime: null,

        remark: null,
      },
      // 表单参数
      form: {
        // domains: [
        //   {
        //     fileName: "",
        //     fileUrl: "",
        //   }
        // ],
      },
      // 表单校验
      rules: {
        name: [{ required: true, message: "请输入名称", trigger: "blur" }],
      },
      fileList: [],
      fileNameS: [],
      files: [],
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 导入按钮操作 */
    exportFile() {
      this.$refs.importdialog.open();
    },
    /** 查询约谈流程列表 */
    getList() {
      this.loading = true;
      this.queryParams.params = {};
      if (null != this.daterangeCreateTime && "" != this.daterangeCreateTime) {
        this.queryParams.params["beginCreateTime"] =
          this.daterangeCreateTime[0];
        this.queryParams.params["endCreateTime"] = this.daterangeCreateTime[1];
      }
      if (null != this.daterangeUpdateTime && "" != this.daterangeUpdateTime) {
        this.queryParams.params["beginUpdateTime"] =
          this.daterangeUpdateTime[0];
        this.queryParams.params["endUpdateTime"] = this.daterangeUpdateTime[1];
      }
      listYtlc(this.queryParams).then((response) => {
        this.ytlcList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,

        name: null,

        fileName: null,

        fileUrl: null,

        createBy: null,

        createTime: null,

        updateBy: null,

        updateTime: null,

        remark: null,

        // domains: [
        //   {
        //     fileName: "",
        //     fileUrl: "",
        //   }
        // ],
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.daterangeCreateTime = [];
      this.daterangeUpdateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /**查看按钮操作 */
    handleInfo(row) {
      this.reset();
      this.files = [];
      const id = row.id || this.ids;
      getYtlc(id).then((response) => {
        this.form = response.data;
        let arr1 = this.form.fileName.split(",");
        let arr2 = this.form.fileUrl.split(",");
        if (arr1[0] !== "" && arr1.length > 0 && arr2.length > 0) {
          arr1.forEach((item, index) => {
            let obj = {};
            obj.name = item;
            obj.url = arr2[index];
            this.files.push(obj);
          });
        } else {
          this.files = [];
        }
        this.infoOpen = true;
        this.infoTitle = "查看约谈流程详情";
      });
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.fileNameS = [];
      this.open = true;
      this.title = "添加约谈流程";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.fileNameS = [];
      const id = row.id || this.ids;
      getYtlc(id).then((response) => {
        // console.log(response.data,'response.data')
        this.form = response.data;
        // this.form.name = response.data.name;
        // this.form.createTime = response.data.createTime;
        // this.form.remark = response.data.remark;
        // this.form.id = response.data.id;
        // console.log(this.form,'this.form')
        if (response.data.fileName && response.data.fileUrl) {
          let arr1 = response.data.fileName.split(",");
          let arr2 = response.data.fileUrl.split(",");
          arr1.forEach((value, index) => {
            this.fileNameS.push({
              name: value,
              url: arr2[index],
            });
          });
        }
        // console.log(this.fileNameS,'this.fileNameS')
        this.open = true;
        this.title = "修改约谈流程";
      });
    },
    /** 提交按钮 */
    submitForm() {
      let arr1 = [];
      let arr2 = [];
      let reg = new RegExp("http");
      if (this.fileNameS.length > 0) {
        this.fileNameS.forEach((value) => {
          arr1.push(value.name);
          if (reg.test(value.url)) {
            arr2.push(value.url);
          } else {
            arr2.push(process.env.VUE_APP_BASE_API + value.url);
          }
        });
        this.form.fileName = arr1.join(",");
        this.form.fileUrl = arr2.join(",");
      } else {
        this.form.fileName = "";
        this.form.fileUrl = "";
      }
      console.log(this.form, "this.form");
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            console.log(this.form);
            updateYtlc(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addYtlc(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delYtlc(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有约谈流程数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.download(
            "/tcZz/netManage/ytlc/export",
            {
              ...this.queryParams,
            },
            "约谈流程_" + new Date().getTime() + ".xlsx"
          );
          this.exportLoading = false;
        })
        .catch(() => {});
    },
    addDomain() {
      this.form.domains.push({
        fileUrl: "",
        fileName: "",
      });
      console.log(this.form.domains, "domains");
    },
    removeDomain(item) {
      var index = this.form.domains.indexOf(item);
      // console.log(index,'index')
      if (index !== -1) {
        this.form.domains.splice(index, 1);
      }
    },
  },
};
</script>
<style lang="scss" scoped>
// ::v-deep .el-dialog {
//   .el-dialog__body {
//     .el-form {
//       .file-item {
//         display:flex;
//         // .el-form-item__content {
//         //   display:flex;
//         //   // .my-input {
//         //   //   margin: 0 10px;
//         //   // }
//         // }
//         .el-button {
//           height: 35px;
//         }
//       }
//     }
//   }
// }
a {
  color: #0072c6;
  margin: 0 5px;
}
</style>